<script lang="ts">
  export let show;

  let clientHeight = 0;
  let isOverflow;

  const clickOutside = (node) => {
    const handleClick = (event) => {
      if (!node.contains(event.target)) {
        node.dispatchEvent(new CustomEvent('outclick'));
      }
    };

    document.addEventListener('click', handleClick, true);

    return {
      destroy() {
        document.removeEventListener('click', handleClick, true);
      },
    };
  };

  $: isOverflow = clientHeight > window.innerHeight;
</script>

<div
  tabindex="-1"
  aria-hidden="true"
  class="{!show ? 'hidden' : ''} w-full fixed left-0 top-0 right-0 z-50 md:inset-0 h-full
  backdrop-blur-sm overflow-y-auto overflow-x-hidden flex justify-center items-end"
>
  {#if show}
    <div
      use:clickOutside
      on:outclick={null}
      bind:clientHeight
      class="absolute {isOverflow ? 'top-0' : 'top-1/2 -translate-y-1/2'} w-full max-w-2xl"
    >
      <slot></slot>
    </div>
  {/if}
</div>
